export default {
  inserted: function (el) {

    el.addEventListener('mousedown', function(event) {
        rippler(event, el);
    });

    function rippler(event, el) {
      var target = el;

      // Get necessary variables
      var rect        = target.getBoundingClientRect(),
          left        = rect.left,
          top         = rect.top,
          width       = target.offsetWidth,
          height      = target.offsetHeight,
          offsetTop   = target.offsetTop,
          offsetLeft  = target.offsetLeft,
          dx          = event.clientX - left,
          dy          = event.clientY - top,
          maxX        = Math.max(dx, width - dx),
          maxY        = Math.max(dy, height - dy),
          style       = window.getComputedStyle(target),
          radius      = Math.sqrt((maxX * maxX) + (maxY * maxY));

      // Create the ripple and its container
      var ripple = document.createElement("div"),
          rippleContainer = document.createElement("div");

      // Add class, append and set location
      ripple.classList.add("ripple-effect");
      rippleContainer.classList.add("ripple-container");
      rippleContainer.appendChild(ripple);
      document.body.appendChild(rippleContainer);

      ripple.setAttribute('style','margin-top: 0px;margin-left: 0px;width: 1px;height: 1px;background-color: rgba(0, 0, 0, 0.033);transition: all 0.4s cubic-bezier(0.4, 0, 0.2, 1);border-radius: 50%;pointer-events: none;');
      rippleContainer.setAttribute('style', 'position: absolute;left: 0;top: 0;height: 0;width: 0;pointer-events: none;overflow: hidden;')

      // Add optional colour adjustemnts
      if (target.classList.contains("light")) {
        ripple.style.backgroundColor = 'rgba(255, 255, 255, 0.15)'
      }
      else if (target.classList.contains("dark")) {
        ripple.style.backgroundColor = 'rgba(0, 0, 0, 0.075)'
      }

      ripple.style.marginLeft   = dx + "px";
      ripple.style.marginTop    = dy + "px";

      rippleContainer.style.left    = left + (((window.pageXOffset || document.scrollLeft) - (document.clientLeft || 0)) || 0) + "px";
      rippleContainer.style.top     = top + (((window.pageYOffset || document.scrollTop) - (document.clientTop || 0)) || 0) + "px";
      rippleContainer.style.width   = width + "px";
      rippleContainer.style.height  = height + "px";
      rippleContainer.style.borderTopLeftRadius  = style.borderTopLeftRadius;
      rippleContainer.style.borderTopRightRadius  = style.borderTopRightRadius;
      rippleContainer.style.borderBottomLeftRadius  = style.borderBottomLeftRadius;
      rippleContainer.style.borderBottomRightRadius  = style.borderBottomRightRadius;

      setTimeout(function() {
        ripple.style.width  = radius * 2 + "px";
        ripple.style.height = radius * 2 + "px";
        ripple.style.marginLeft   = dx - radius + "px";
        ripple.style.marginTop    = dy - radius + "px";
      }, 0);

      setTimeout(function() {
        ripple.style.backgroundColor = "rgba(0, 0, 0, 0)";
      }, 250);

      setTimeout(function() {
        ripple.parentElement.removeChild(ripple);
        rippleContainer.parentElement.removeChild(rippleContainer);
      }, 650);
    }
  }
}
